Subject: Re: bug#23855: --no-substitutes still triggers update to list of substitutes

From: [email-masked] (Ludovic Courtès)
Date: Tue, 28 Jun 2016 14:33:39 +0200

Hello!

Troy Sankey <[email-masked]> skribis:

> I'm not totally sure about this, but my assertion is that the list of
> substitutes should not be updated if --no-substitutes is present on the command
> line.  However, guix version 0.10.0 fails my assertion.  

You are correct: --no-substitutes should entirely inhibit connections to
the substitute servers.

> Example output:
>
>
>   $ guix package --dry-run --no-substitutes -i st
>   warning: failed to install locale: Invalid argument
>   substitute: warning: failed to install locale: Invalid argument
>   substitute: updating list of substitutes from 'http://hydra.gnu.org'... 100.0%
>   The following package would be installed:
>      st   0.6     /gnu/store/fsnk8lc7j1w20id5hfssmd8cv9z8g1na-st-0.6
>   
>   The following derivations would be built:
>      /gnu/store/59560f3snqnxgn991kq9wlsap6yp2p0q-profile.drv
>      /gnu/store/hnnc1n5z6f4qv6q0i04fny1725g633b5-info-dir.drv
>      /gnu/store/f0nlagyzpyhykhn752gv5jv71fm74msx-ca-certificate-bundle.drv
>      /gnu/store/lc6wxgz6m521zamdjb0kmd86rhn3l0jh-liberation-fonts-ttf-2.00.1.tar.gz.drv
>      /gnu/store/lh56wp7v0w6xbga9rc19fp236ii1jjlf-libXfixes-5.0.1.tar.bz2.drv
>      /gnu/store/iqi33bhmydkjk47ib4hykp9hx5dgv91x-libXcomposite-0.4.4.tar.bz2.drv
>      /gnu/store/1d5zjlry87gcmbmwqj69jjkpfmr1kyin-compositeproto-0.4.2.drv
>      /gnu/store/50mqcf0nhmyp6l94iy7yif1wzw0mbx1s-fixesproto-5.0.drv
>      /gnu/store/6alkhqglqns5a8y4zk750bdbn6gwyk6p-st-0.6.tar.gz.drv
>      /gnu/store/a80b8rqkagg7qwnhpy75vnam3pvh8x1r-libxcomposite-0.4.4.drv
>      /gnu/store/cj2yqxm365qbx6kww46913i7s27jyhaf-libxfixes-5.0.1.drv
>      /gnu/store/sz9n1mx93c5s7mvz90my8072xq68xa43-font-liberation-2.00.1.drv
>      /gnu/store/1jlmi4y2yszzdpjsw3qcbq9073ma938k-st-0.6.drv
>      /gnu/store/2l5l3vx61i287c4sq1ds4g68r2dsmzaa-st-0.6.drv
>
>   $ guix --version
>   warning: failed to install locale: Invalid argument
>   guix (GNU Guix) 0.10.0
>   Copyright (C) 2016 the Guix authors
>   License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
>   This is free software: you are free to change and redistribute it.
>   There is NO WARRANTY, to the extent permitted by law.
>
>
> Note the line which contains "substitute: updating list of substitutes [...]".
>
> Guix 0.10.0 is the version I get when I run `guix package -i guix`.

Commit 151afd84dc9bf8f13de79a689f7f163fba7254ec (May 31st) fixed
something in this area.  However, the change is in ‘guix-daemon’, so you
need to build and install ‘guix-daemon’ to take advantage of it (the
current ‘guix’ package with version 0.10.0-0.e901 is older than this
change.)

HTH,
Ludo’.